Public Class GitarrengriffEditor

    Private m_AngeboteneGriffe As New List(Of Gitarrengriff)

    Private m_GriffeImText As New List(Of GitarrengriffImText)

    Private m_SelectedGitarrenGriff As GitarrengriffImText

    Private m_ZeilenZahl As Integer = 0

    Private m_MouseDistance As Size

    Private m_LiedTextZeilen() As String
    WriteOnly Property LiedTextZeilen() As String()
        Set(ByVal value As String())
            m_LiedTextZeilen = value
            m_GriffeImText.Clear()
            m_ZeilenZahl = m_LiedTextZeilen.GetUpperBound(0) + 1
            m_SelectedGitarrenGriff = Nothing
            Invalidate()
        End Set
    End Property

    Public Sub New()
        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_AngeboteneGriffe.Add(New Gitarrengriff("E", Color.LightBlue))
        m_AngeboteneGriffe.Add(New Gitarrengriff("A", Color.LightCoral))
        m_AngeboteneGriffe.Add(New Gitarrengriff("D", Color.LightCyan))
        m_AngeboteneGriffe.Add(New Gitarrengriff("G", Color.LightGoldenrodYellow))
        m_AngeboteneGriffe.Add(New Gitarrengriff("H", Color.LightGray))

        Me.SetStyle(ControlStyles.DoubleBuffer Or ControlStyles.UserPaint _
    Or ControlStyles.AllPaintingInWmPaint, True)

    End Sub

    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(pe)

        'Benutzerdefinierten Zeichnungscode hier einfügen
        Dim g As Graphics = pe.Graphics
        g.Clear(Color.White)


        Dim TmpBreite As Single
        If m_ZeilenZahl > 0 Then
            Dim NotwendigeBreite As Single = 0.0F
            Dim NotwendigeHoehe As Single = 15.0F + m_ZeilenZahl * CSng(Me.Font.Height) * 2.0F
            For Each txt As String In m_LiedTextZeilen
                TmpBreite = g.MeasureString(txt, Me.Font).Width
                If TmpBreite > NotwendigeBreite Then
                    NotwendigeBreite = TmpBreite
                End If
            Next
            Me.AutoScrollMinSize = New Size(NotwendigeBreite, NotwendigeHoehe)
        End If





        Dim Zaehler As Integer = 0
        Dim Brsh As SolidBrush = Nothing
        Dim Rect As Rectangle
        For Each Grf As Gitarrengriff In m_AngeboteneGriffe
            Brsh = New SolidBrush(Grf.Farbe)
            Rect = New Rectangle(Zaehler * 30 + Me.AutoScrollPosition.X, 0 + Me.AutoScrollPosition.Y, 30, 15)
            g.FillRectangle(Brsh, Rect)
            g.DrawString(Grf.Bezeichnung, Me.Font, Brushes.Black, Zaehler * 30 + Me.AutoScrollPosition.X, 1 + Me.AutoScrollPosition.Y)
            ControlPaint.DrawVisualStyleBorder(g, Rect)
            Zaehler += 1
        Next
        Brsh.Dispose()

        Rect = New Rectangle(Zaehler * 30 + Me.AutoScrollPosition.X + 5, 1 + Me.AutoScrollPosition.Y, 16, 16)
        g.DrawImage(My.Resources.Papierkorb, Rect)

        If m_ZeilenZahl > 0 Then
            Dim Zwischenhoehe As Single = 15.0F
            Dim Zeilenhoehe As Single = Me.Font.Height
            For Each txt As String In m_LiedTextZeilen
                Zwischenhoehe += Zeilenhoehe
                g.DrawString(txt, Me.Font, Brushes.Black, 0.0F + Me.AutoScrollPosition.X, Zwischenhoehe + Me.AutoScrollPosition.Y)
                Zwischenhoehe += Zeilenhoehe
            Next

            For Each grf As GitarrengriffImText In m_GriffeImText
                Dim OPos As Integer = Me.AutoScrollPosition.Y + 15 + grf.Zeile * Me.Font.Height * 2
                Dim txt As String = m_LiedTextZeilen(grf.Zeile).Substring(0, grf.BuchstabenPosition)
                Dim LPos As Integer = Me.AutoScrollPosition.X + g.MeasureString(txt, Me.Font).Width

                Brsh = New SolidBrush(grf.Griff.Farbe)

                Rect = New Rectangle(LPos, OPos, 30, 15)
                g.FillRectangle(Brsh, Rect)
                g.DrawString(grf.Griff.Bezeichnung, Me.Font, Brushes.Black, LPos, OPos)
                ControlPaint.DrawVisualStyleBorder(g, Rect)

                Brsh.Dispose()

            Next


            If m_SelectedGitarrenGriff IsNot Nothing Then
                Brsh = New SolidBrush(m_SelectedGitarrenGriff.Griff.Farbe)

                Rect = New Rectangle(m_SelectedGitarrenGriff.Location.X + Me.AutoScrollPosition.X, m_SelectedGitarrenGriff.Location.Y + Me.AutoScrollPosition.Y, 30, 15)
                g.FillRectangle(Brsh, Rect)
                g.DrawString(m_SelectedGitarrenGriff.Griff.Bezeichnung, Me.Font, Brushes.Black, m_SelectedGitarrenGriff.Location.X + Me.AutoScrollPosition.X, m_SelectedGitarrenGriff.Location.Y + Me.AutoScrollPosition.Y)
                ControlPaint.DrawVisualStyleBorder(g, Rect)

                Brsh.Dispose()

            End If
        End If

        ControlPaint.DrawVisualStyleBorder(g, New Rectangle(0, 0, Me.Width - 1, Me.Height - 1))


    End Sub


    Private Sub GitarrengriffEditor_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        Dim PosX As Integer = e.X - Me.AutoScrollPosition.X
        Dim PosY As Integer = e.Y - Me.AutoScrollPosition.Y

        If PosY < 16 Then
            Dim Zahl As Integer = PosX \ 30
            If Zahl > -1 AndAlso Zahl < m_AngeboteneGriffe.Count Then
                m_SelectedGitarrenGriff = New GitarrengriffImText(m_AngeboteneGriffe(Zahl))
                Dim BreitenAbstand, HoehenAbstand As Integer
                BreitenAbstand = PosX - Zahl * 30
                HoehenAbstand = PosY
                m_MouseDistance = New Size(BreitenAbstand, HoehenAbstand)

                m_SelectedGitarrenGriff.Location = New Point(PosX - BreitenAbstand, PosY - HoehenAbstand)
                Invalidate()

            End If
        Else
            'hier kommt noch in Frage, dass ein Griff im Text selektiert werden soll
            For Each grf As GitarrengriffImText In m_GriffeImText
                If grf.Location.X < PosX AndAlso grf.Location.X + 30 > PosX Then
                    If grf.Location.Y < PosY AndAlso grf.Location.Y + 15 > PosY Then

                        m_SelectedGitarrenGriff = grf
                        m_GriffeImText.Remove(grf)
                        Dim BreitenAbstand, HoehenAbstand As Integer
                        BreitenAbstand = PosX - grf.Location.X
                        HoehenAbstand = PosY - grf.Location.Y
                        m_MouseDistance = New Size(BreitenAbstand, HoehenAbstand)
                        Invalidate()
                        Exit For
                    End If
                End If
            Next

        End If
    End Sub

    Private Sub GitarrengriffEditor_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If m_SelectedGitarrenGriff Is Nothing Then Exit Sub

        Dim PosX As Integer = e.X - Me.AutoScrollPosition.X
        Dim PosY As Integer = e.Y - Me.AutoScrollPosition.Y

        m_SelectedGitarrenGriff.Location = New Point(PosX - m_MouseDistance.Width, PosY - m_MouseDistance.Height)
        Invalidate()
    End Sub

    Private Sub GitarrengriffEditor_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        If m_SelectedGitarrenGriff Is Nothing Then Exit Sub

        Dim PosX As Integer = e.X - Me.AutoScrollPosition.X - m_MouseDistance.Width
        Dim PosY As Integer = e.Y - Me.AutoScrollPosition.Y

        If PosY > 15 Then
            Dim Zeile As Integer = (PosY - 15) \ (Me.Font.Height * 2.0F)
            If Zeile < m_ZeilenZahl Then
                Dim PositionImText As Integer = -1
                Dim g As Graphics = Me.CreateGraphics
                Dim NewLeft As Single = 0
                Dim OldLeft As Single = 0
                If m_LiedTextZeilen(Zeile).Length = 0 Then
                    PositionImText = 0
                    OldLeft = 0
                Else
                    For I As Integer = 1 To m_LiedTextZeilen(Zeile).Length
                        OldLeft = NewLeft
                        NewLeft = g.MeasureString(m_LiedTextZeilen(Zeile).Substring(0, I), Me.Font).Width
                        If NewLeft > PosX Then
                            PositionImText = I - 1
                            Exit For
                        End If
                    Next
                End If
                If PositionImText = -1 Then
                    PositionImText = m_LiedTextZeilen(Zeile).Length
                End If

                Dim NewTop As Integer = 15 + CSng(Zeile * Me.Font.Height) * 2.0F

                m_SelectedGitarrenGriff.Location = New Point(OldLeft, NewTop)
                m_SelectedGitarrenGriff.Zeile = Zeile
                m_SelectedGitarrenGriff.BuchstabenPosition = PositionImText
                m_GriffeImText.Add(m_SelectedGitarrenGriff)
            End If
        End If


        m_SelectedGitarrenGriff = Nothing
        Invalidate()
    End Sub

    Private Sub GitarrengriffEditor_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Invalidate()
    End Sub

    Private Sub GitarrengriffEditor_Scroll(ByVal sender As Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles Me.Scroll
        Invalidate()
    End Sub
End Class
